#script expects one parameter (original Gerber X2 file) 
use Digest::MD5;

local $_ = shift;
local *IN;
my $content;
my $origMD5 = "";

local $/;
open(IN, "<$_") or die "Cannot open $_ due to $!";
$content = <IN>;       #read file to the variable
close IN;
my $md5start = index($content,"%TF.MD5,");  #try to find MD5 info
if ($md5start != -1){    #safe original MD5 if possible
  $origMD5 = uc(substr($content, 8 + $md5start, 32));
  $content =~ s/\%TF.MD5,[a-fA-F0-9]{32}\*\%//;   #remove existing MD5
} 
$content =~ s/\r|\n//g;  #remove all CRLF (end of line) characters
$content =~ s/M02\*//;   #remove M02 from the end of file

#calculate MD5
$md5 = Digest::MD5->new; #init MD5
$md5->add($content);     #send content of the file to MD5 engine
my $countedMD5 = uc("" . $md5->hexdigest);

if ($origMD5 eq ""){
  print "Add 2 following lines to the Gerber file, please.\n"; #missing MD5 hash
  print "%TF.MD5," . $countedMD5 . "*%\nM02*\n\n";
}
elsif ($origMD5 eq $countedMD5){
  print "File contains correct MD5 checksum.\n";   #correct MD5 hash
} 
else{
  print "File contains incorrect MD5 checksum! There should be:\n";   #incorrect MD5 hash
  print "%TF.MD5," . $countedMD5 . "*%\nM02*\n\n";
}
